boots = function(v)
    sample(v, length(v), rep = T)

boot.compare = function(y, g, stat, n = 10000, seed = 3)
   {y1 = y[g == levels(g)[1]]
    y2 = y[g == levels(g)[2]]
    set.seed(seed)
    s1 = replicate(n, stat(boots(y1)))
    d = quantile(s1, c(.025, .975))
    s2 = replicate(n, stat(boots(y2)))
    d = rbind(d, quantile(s2, c(.025, .975)))
    p = mean(s1 > s2)
    ineq = sprintf("%s > %s", levels(g)[1], levels(g)[2])
    if (p < .5)
       {p = 1 - p
        ineq = sprintf("%s > %s", levels(g)[2], levels(g)[1])}
    d = rbind(
        format(cbind(data.frame(signif(d, 2)), 0), drop0trailing = F),
        c("", "", sprintf("%0.2f", p)))
    row.names(d) = c(levels(g), ineq)
    names(d) = qw(lo, hi, "conf")
    d[levels(g), "conf"] = ""
    d}




